{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_ReadShowTerm
  ( d_C_showTerm
  , nd_C_showTerm
  , d_C_readsUnqualifiedTerm
  , nd_C_readsUnqualifiedTerm
  , d_C_readUnqualifiedTerm
  , nd_C_readUnqualifiedTerm )
  where

import Basics
import qualified Curry_Prelude


d_C_showTerm :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showTerm x1 x2 cd cs = Curry_Prelude.d_OP_dollar_hash_hash d_C_prim_showTerm
  x2 cd cs

nd_C_showTerm :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C_showTerm x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dollar_hash_hash (wrapDX id d_C_prim_showTerm)
  x2 s0 cd cs

d_C_readsUnqualifiedTerm :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_readsUnqualifiedTerm x1 x2 x3 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "ReadShowTerm.readsUnqualifiedTerm: list of module prefixes is empty") cd cs
  Curry_Prelude.OP_Cons x4 x5 -> d_C_readsUnqualifiedTermWithPrefixes x1
    (Curry_Prelude.OP_Cons x4 x5) x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_readsUnqualifiedTerm
    x1 l x3 cd cs) (d_C_readsUnqualifiedTerm x1 r x3 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_readsUnqualifiedTerm x1 z x3 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_C_readsUnqualifiedTerm x1 e x3 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "ReadShowTerm.readsUnqualifiedTerm" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "ReadShowTerm.readsUnqualifiedTerm" (showCons x2))

nd_C_readsUnqualifiedTerm :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_C_readsUnqualifiedTerm x1 x2 x3 s cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "ReadShowTerm.readsUnqualifiedTerm: list of module prefixes is empty") cd cs
  Curry_Prelude.OP_Cons x4 x5 -> let s0 = s
    in s0 `seq` nd_C_readsUnqualifiedTermWithPrefixes x1 (Curry_Prelude.OP_Cons
    x4 x5) x3 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_readsUnqualifiedTerm
    x1 l x3 s cd cs) (nd_C_readsUnqualifiedTerm x1 r x3 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_C_readsUnqualifiedTerm x1 z x3 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    nd_C_readsUnqualifiedTerm x1 e x3 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "ReadShowTerm.readsUnqualifiedTerm" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "ReadShowTerm.readsUnqualifiedTerm" (showCons x2))

d_C_readsUnqualifiedTermWithPrefixes :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_readsUnqualifiedTermWithPrefixes x1 x2 x3 cd cs =
  Curry_Prelude.d_OP_dollar_hash_hash (Curry_Prelude.d_OP_dollar_hash_hash
  (acceptCs id d_C_prim_readsUnqualifiedTerm) x2 cd cs) x3 cd cs

nd_C_readsUnqualifiedTermWithPrefixes :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_C_readsUnqualifiedTermWithPrefixes x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar_hash_hash
  (Curry_Prelude.nd_OP_dollar_hash_hash (wrapDX (wrapDX id) (acceptCs id
  d_C_prim_readsUnqualifiedTerm)) x2 s0 cd cs) x3 s1 cd cs))

d_C_readUnqualifiedTerm :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> t0
d_C_readUnqualifiedTerm x1 x2 x3 cd cs = let x4 = d_C_readsUnqualifiedTerm x1 x2
                                               x3 cd cs
  in d_C__case_3 x4 cd cs

nd_C_readUnqualifiedTerm :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> t0
nd_C_readUnqualifiedTerm x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` (let x4 = nd_C_readsUnqualifiedTerm x1 x2 x3 s0 cd cs
  in d_C__case_3 x4 cd cs)

d_C_prim_showTerm :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_prim_showTerm x1 cd cs = external_d_C_prim_showTerm x1 cd cs

d_C_prim_readsUnqualifiedTerm :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_prim_readsUnqualifiedTerm x1 x2 cd cs =
  external_d_C_prim_readsUnqualifiedTerm x1 x2 cd cs

d_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Cover -> ConstStore -> t0
d_C__case_3 x4 cd cs = case x4 of
  Curry_Prelude.OP_Cons x5 x6 -> d_C__case_2 x6 x5 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "ReadShowTerm.readUnqualifiedTerm: no parse") cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_3 l cd cs)
    (d_C__case_3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_3 z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "ReadShowTerm._case_3" [show x4] info)
  _ -> failCons cd (consFail "ReadShowTerm._case_3" (showCons x4))

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Cover -> ConstStore -> t0
d_C__case_2 x6 x5 cd cs = case x5 of
  Curry_Prelude.OP_Tuple2 x7 x8 -> d_C__case_1 x8 x7 x6 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_2 x6 l cd cs)
    (d_C__case_2 x6 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_2 x6
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_2 x6 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ReadShowTerm._case_2" [show x6, show x5] info)
  _ -> failCons cd (consFail "ReadShowTerm._case_2" (showCons x5))

d_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> t0 -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore -> t0
d_C__case_1 x8 x7 x6 cd cs = case x6 of
  Curry_Prelude.OP_List -> d_C__case_0 x8 x7 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_all Curry_Prelude.d_C_isSpace cd cs) x8 cd cs) cd cs
  Curry_Prelude.OP_Cons x9 x10 -> Curry_Prelude.d_C_error
    (Curry_Prelude.toCurryString
    "ReadShowTerm.readUnqualifiedTerm: ambiguous parse") cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_1 x8 x7 l cd cs)
    (d_C__case_1 x8 x7 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_1 x8
    x7 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_1 x8 x7 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "ReadShowTerm._case_1" [show x8, show x7, show x6] info)
  _ -> failCons cd (consFail "ReadShowTerm._case_1" (showCons x6))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> t0
d_C__case_0 x8 x7 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> x7
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_error
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "ReadShowTerm.readUnqualifiedTerm: no parse, ")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "unmatched string after term: ") x8 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x8 x7 l cd cs)
    (d_C__case_0 x8 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x8 x7
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x8 x7 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "ReadShowTerm._case_0" [show x8, show x7, show x9] info)
  _ -> failCons cd (consFail "ReadShowTerm._case_0" (showCons x9))

external_d_C_prim_showTerm :: Show a => a -> Cover -> ConstStore -> Curry_Prelude.C_String 
external_d_C_prim_showTerm t _ _ = toCurry (show t) 
 
external_d_C_prim_readsUnqualifiedTerm :: 
  Read a => Curry_Prelude.OP_List Curry_Prelude.C_String -> Curry_Prelude.C_String -> 
          Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 a Curry_Prelude.C_String) 
external_d_C_prim_readsUnqualifiedTerm _ s _ _ = toCurryPairs (reads (fromCurry s)) 
  where 
   toCurryPairs [] = Curry_Prelude.OP_List 
   toCurryPairs ((v,s):xs) = Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 v (toCurry s)) 
                                        (toCurryPairs xs) 
